CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRLB, CR, #16, CLS      ' PST formmatting control
  ' Enable/Disenable work
  ' 1, 3 7, ok 15 broke all on
  ' 128, 192 ok 224 all on
  ' two pins appear to work but not 3 pins or 4 pins
OBJ
  Sio  : "FullDuplexSerialPlus"        
  vp : "Conduit"                             ' Declare ViewPort conduit
  qs : "QuickSample"                         ' Declare 
VAR
  byte oe
  byte clk
  byte latch
  byte data
  long frame[400]
  long value
  long trigger
  
Pub Main | i
'  Sio.start(31,30,0,115200)  ' Rx,Tx, Mode, Baud
'  Sio.start(8,9,0,115200)  ' Rx,Tx, Mode, Baud      XBee
  vp.config(string("var:io,v1,v2"))
  vp.config(string("start:lsa"))
  vp.config(string("dso:timescale=10ms"))
  vp.config(string("lsa:view=io,trigger=io[0]r,timescale=50s"))
  vp.register(qs.sampleINA(@frame,1))        'sample INA into <frame> array
  vp.share(@value, @trigger)
  value := 0
  trigger := 1
  repeat until value > 0
  Start(3, 0, 2, 1)
  Enable
  repeat
    Set(value)
    if trigger == 0
      Disenable
    else
      Enable
'    waitcnt(clkfreq  + cnt)
     
PUB Start(_oe, _clk, _latch, _data)
  oe := _oe
  dira[oe]~~                    ' output
  outa[oe]~~                    ' high, disable outputs
  clk := _clk
  dira[clk]~~                   ' output
  outa[clk]~                    ' low
  latch := _latch
  dira[latch]~~                 ' output
  outa[latch]~                  ' low
  data := _data
  dira[data]~~                  ' output

PUB Set(pinStates)
  repeat  8
    outa[data] := pinStates >> 7     ' put data on serial data in
    pinStates <<= 1
    !outa[clk]                  ' clock high
    !outa[clk]                  ' clock low
    
  !outa[latch]                  ' latch high
  !outa[latch]                  ' latch low            
                          
PUB Enable
  outa[oe]~                     ' low, enable outputs

PUB Disenable
  outa[oe]~~                    ' high, disable outputs







          